package com.bonus.material.ma.service;

import java.util.List;

import com.bonus.common.biz.domain.lease.LeaseApplyInfo;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.material.lease.domain.vo.LeaseApplyRequestVo;
import com.bonus.material.ma.domain.Machine;
import com.bonus.material.ma.domain.MachineSynch;
import com.bonus.material.ma.domain.Type;
import com.bonus.material.ma.domain.vo.MachineVo;

/**
 * 机具设备管理Service接口
 *
 * @author xsheng
 * @date 2024-09-27
 */
public interface IMachineService
{
    /**
     * 查询机具设备管理
     *
     * @param maId 机具设备管理主键
     * @return 机具设备管理
     */
    public MachineVo selectMachineByMaId(Long maId);

    /**
     * 查询机具设备管理列表
     *
     * @param machine 机具设备管理
     * @return 机具设备管理集合
     */
    public List<MachineVo> selectMachineList(Machine machine);

    /**
     * 新增机具设备管理
     *
     * @param machine 机具设备管理
     * @return 结果
     */
    public int insertMachine(Machine machine);

    /**
     * 修改机具设备管理
     *
     * @param machine 机具设备管理
     * @return 结果
     */
    public AjaxResult updateMachine(Machine machine);

    /**
     * 批量删除机具设备管理
     *
     * @param maIds 需要删除的机具设备管理主键集合
     * @return 结果
     */
    public int deleteMachineByMaIds(Long[] maIds);

    /**
     * 删除机具设备管理信息
     *
     * @param maId 机具设备管理主键
     * @return 结果
     */
    public AjaxResult deleteMachineByMaId(Long maId);

    /**
     * 根据类型查询机具设备管理列表
     * @param type
     * @return
     */
    AjaxResult selectByTypeList(Type type);

    /**
     * todo 查询在库机具编号，存在数据拼接，盘点报废专用
     * @param type
     * @return
     */
    AjaxResult getMachineList(Type type);

    /**
     * todo 查询电子标签
     * @param machine
     * @return
     */
    AjaxResult getElectronicLabel(Machine machine);

    /**
     * 根据标签信息查询出库单
     * @param leaseApplyInfo
     * @return
     */
    LeaseApplyRequestVo getInfoByMaId(LeaseApplyInfo leaseApplyInfo);

    /**
     * 电子标签编码查询
     * @param machine
     * @return
     */
    List<Machine> getByMaCode(Machine machine);

    /**
     * 同步报告
     *
     * @param machine 同步报告
     * @return 结果
     */
    public AjaxResult synchReport(Machine machine);

    /**
     * 固定资产编号录入
     *
     * @param machine 固定资产编号录入
     * @return 结果
     */
    public int editAssetsCode(Machine machine);

    AjaxResult getHisByQrcode(Machine machine);

    AjaxResult getHisByCode(Machine machine);

    /**
     * 编码铭牌信息
     * @param machine
     * @return
     */
    List<Machine> getInfoByMaCode(Machine machine);

    /**
     * 根据类型id获取编码
     * @param machine
     * @return
     */
    List<Machine> getInfoByTypeId(Machine machine);

    /**
     * 根据编码查询机具历史信息-New查询安全工器具和工器具
     * @param machine
     * @return
     */
    AjaxResult getHisByCodeNew(Machine machine);

    AjaxResult editMachineStatus(Machine machine);

    List<Machine> getNewByMaCode(Machine machine);

    List<Machine> findMaMsgById(Machine machine);

    /**
     * 新增机具设备管理
     *
     * @param machine 机具设备管理
     * @return 结果
     */
    AjaxResult addMaMachine(Machine machine);

    List<MachineSynch> selectSynchList(MachineSynch machine);

    List<MachineSynch> selectSynchDetailList(MachineSynch machine);

    /**
     * 批量更新检验时间
     * @param info
     * @return
     */
    AjaxResult updateDate(Machine info);
}
